//  IBM_PROLOG_BEGIN_TAG
//  This is an automatically generated prolog.
//
//  $Source: src/include/usr/vfs/vfs.H $
//
//  IBM CONFIDENTIAL
//
//  COPYRIGHT International Business Machines Corp. 2011
//
//  p1
//
//  Object Code Only (OCO) source materials
//  Licensed Internal Code Source Materials
//  IBM HostBoot Licensed Internal Code
//
//  The source code for this program is not published or other-
//  wise divested of its trade secrets, irrespective of what has
//  been deposited with the U.S. Copyright Office.
//
//  Origin: 30
//
//  IBM_PROLOG_END
#ifndef __USR_VFS_H
#define __USR_VFS_H

#include <errl/errlentry.H>
#include <sys/vfs.h>

namespace VFS
{
    /** 
     * Load or unload a module from the extended image.
     * @param[in] i_module Module name
     * @param[in] i_msgtype [VFS_MSG_LOAD | VFS_MSG_UNLOAD]
     * @return errlHandl_t on error
     */
    errlHndl_t module_load_unload(const char * i_module, VfsMessages i_msgtype);

    /**
     * Loads a module from the extended image and initializes it
     * @param[in] i_module Module name
     * @return errlHndl_t on error
     */
    ALWAYS_INLINE
    inline errlHndl_t module_load(const char * i_module) 
    {
        return VFS::module_load_unload(i_module,VFS_MSG_LOAD);
    }

    /**
     * Destroys and unloads module.
     * @param[in] i_module Module name
     * @return errlHndl_t on error
     */
    ALWAYS_INLINE
    inline errlHndl_t module_unload(const char * i_module)
    {
        return VFS::module_load_unload(i_module, VFS_MSG_UNLOAD);
    }

};

#endif
