//  IBM_PROLOG_BEGIN_TAG
//  This is an automatically generated prolog.
//
//  $Source: src/usr/cxxtest/TestSuite.C $
//
//  IBM CONFIDENTIAL
//
//  COPYRIGHT International Business Machines Corp. 2011
//
//  p1
//
//  Object Code Only (OCO) source materials
//  Licensed Internal Code Source Materials
//  IBM HostBoot Licensed Internal Code
//
//  The source code for this program is not published or other-
//  wise divested of its trade secrets, irrespective of what has
//  been deposited with the U.S. Copyright Office.
//
//  Origin: 30
//
//  IBM_PROLOG_END

// Imported from FSP tree - /src/test/cxxtest/cxxtest/

#ifndef __cxxtest__TestSuite_cpp__
#define __cxxtest__TestSuite_cpp__

#include <stdarg.h>
#include <arch/ppc.H>
#include <kernel/console.H>

#include <cxxtest/TestSuite.H>

namespace CxxTest
{
/******************************************************************************/
// Globals/Constants
/******************************************************************************/

//
// TestSuite members
//
TestSuite::~TestSuite() {}
void TestSuite::setUp() {}
void TestSuite::tearDown() {}

/**
 *
 *   @brief Implement trace action in unit tests
 *
 *   @return void
 *
 */
void doTrace( )
{

    __sync_add_and_fetch( &g_TraceCalls, 1 );

}

/**
 *
 *   @brief Implement warn action in unit tests
 *
 *   @param [in] pointer to filename  (not used right now )
 *   @param [in] line number
 *   @param [in] warning message
 *
 *   @return void
 *
 */
void doWarn( )
{

    __sync_add_and_fetch( &g_Warnings, 1 );

}

/**
 *   @brief Implement Fail action in unit tests
 *
 *   @return none
 */

void doFailTest( )
{

    __sync_add_and_fetch( &g_FailedTests, 1 );

}

/**
 *   @brief Implement Fail action in unit tests
 *
 *   @param [in] pointer to filename  (not used right now )
 *   @param [in] line number
 *
 *   @return none
 */

void doFailTest( const char *filename, uint32_t linenum )
{
    TRACDBIN( g_trac_test,
            "!!!       > Test Failed: ",
            filename,
            strlen( filename) );
    TRACDCOMP( g_trac_test,
            "!!!       >at line %d ",
            linenum );
    __sync_add_and_fetch( &g_FailedTests, 1 );

}
/**
 *  @brief Report total number of unit tests in a test suite
 *
 *  A unit test suite will call this to report how many tests
 *  it has.  The call itself is autogenerated
 *
 *  @param [in] pointer to filename  (not used right now )
 *  @param [in] line number
 *  @param [in] trace message
 *
 *  @return void
 *
 *  @TODO do nothing with the suite name for now, later it may be useful
 *
 */
void reportTotalTests(  const char *suitename,
                        uint64_t numtests )
{

    __sync_add_and_fetch( &g_TotalTests, numtests );
    TRACDBIN( g_trac_test,
            "Suite Completed: ",
            suitename,
            strlen(suitename) );
    // printk( "%s completed %ld tests\n", suitename, numtests);

    return;
}


};

#endif // __cxxtest__TestSuite_cpp__
